// Marcel Ritter
// These script files control the way of elements quest.
// Main task: get the essences of the ice and the fire elemental beeing. A fire pearl and 
// a ice flowerl. Merge the essences with the elemental crystal, that is found in the level 
// lying on an altar.

// In the main room, there are 2 wheels to enable a fire and ice gas source. These
// sourceses (tanks) can be distrubted by the 6 sink-levers. That way the hot or cold gas can be
// directed into the 2 rooms. The desintegrate room and the socket room.
 
// The elementals cannot be killed by usual damage, so the player can use the opposite-
// elemental-gas to desintegrate the elemental, in the according room.

// The killed elementals one gets essences of the elemental, that can be merged with the elemental crystal 
// again including using some elemental gas. This way the crystal gets its full power.  

#include"scripts//functions//fadeOutByWorldID.c"


DebugMessage("init elemental cave");

// Adjustment Variables:
NewLevelVariable("ice_effect_weak","string");  // effects used for the gas in the summoning rooms
NewLevelVariable("ice_effect_strong","string");
NewLevelVariable("fire_effect_weak","string");
NewLevelVariable("fire_effect_strong","string");
NewLevelVariable("mix_effect","string");
NewLevelVariable("crystal_melt","string");
NewLevelVariable("ice_effect_machine","string");
NewLevelVariable("fire_effect_machine","string");

// Effects:
ice_effect_weak     = "E_Elemental_Ice_Small";
ice_effect_strong   = "E_Elemental_Ice_Big"; 
fire_effect_weak    = "E_Elemental_Fire_Small";
fire_effect_strong  = "E_Elemental_Fire_Big";
mix_effect          = "Smoke1";
crystal_melt        = "E_Elemental_FireIce_Big";
ice_effect_machine  = "E_Elemental_Ice_Machine";
fire_effect_machine = "E_Elemental_Fire_Machine";


// Sound Variables
NewLevelVariable("S_PipeLever", "string");
S_PipeLever = "cc_elemental_lever";
NewLevelVariable("S_MagmaFlow", "string");
S_MagmaFlow = "cc_elemental_magma";
NewLevelVariable("S_IceFlow", "string");
S_IceFlow = "cc_elemental_ice";
NewLevelVariable("S_GasMix", "string");
S_GasMix = "cc_elemental_smoke";
NewLevelVariable("S_GasFire", "string");
S_GasFire = "cc_elemental_smoke";
NewLevelVariable("S_GasIce", "string");
S_GasIce = "cc_elemental_smoke";
NewLevelVariable("S_Melt", "string");
S_Melt = "cc_elemental_power_item";

// Internal Variables:

// variables used to show empty ingames once only
NewLevelVariable("rem_kill_fire", "int");
rem_kill_fire = 0;
NewLevelVariable("rem_kill_ice", "int");
rem_kill_ice = 0;
NewLevelVariable("rem_socket", "int");
rem_socket = 0;


// lever synchchronisation for door levers 2 different to be really save
NewLevelVariable("synch1", "int");
synch1 = 0;
NewLevelVariable("synch2", "int");
synch2 = 0;

NewLevelVariable("state_secret", "int");
state_secret = 0; // 0 .. closed, 1 .. opened

NewLevelVariable("state_source1","int"); // pipe with the fire source
NewLevelVariable("state_source2","int"); //       "       ice    "
state_source1 = 0; // 0 .. off, 1 .. on 
state_source2 = 0; 


NewLevelVariable("state_lever_left1", "int"); // levers at pipes numbered from west to east; states: 0 .. off, 1 .. on
NewLevelVariable("state_lever_left2", "int"); // left1 -> leads to secret, left2 -> fire, left3 -> ice
NewLevelVariable("state_lever_left3", "int");
NewLevelVariable("state_lever_right1", "int"); // right1 -> ice, right2 -> fire, right3 -> secret
NewLevelVariable("state_lever_right2", "int");
NewLevelVariable("state_lever_right3", "int");
state_lever_left1 = 0;
state_lever_left2 = 0;
state_lever_left3 = 0;
state_lever_right1 = 0;
state_lever_right2 = 0;
state_lever_right3 = 0;


//NewLevelVariable("ice_candles_on", "int"); // number of burning candles in the ice  room
//NewLevelVariable("fire_candles_on", "int");//                  "               fire
//ice_candles_on = 0;
//fire_candles_on = 0;

NewLevelVariable("gas_amount_ice_at_kill" , "float"); // gas amount at ice elemental summon place
NewLevelVariable("gas_amount_fire_at_kill" , "float");
NewLevelVariable("gas_amount_ice_at_socket" , "float");
NewLevelVariable("gas_amount_fire_at_socket" , "float");
NewLevelVariable("gas_amount_ice_at_secret" , "float");
NewLevelVariable("gas_amount_fire_at_secret" , "float");

gas_amount_ice_at_kill = 0.0;
gas_amount_fire_at_kill = 0.0;
gas_amount_ice_at_socket = 0.0;
gas_amount_fire_at_socket = 0.0;
gas_amount_ice_at_secret = 0.0;
gas_amount_fire_at_secret = 0.0;


NewLevelVariable("fire_elemental_hits", "int");
NewLevelVariable("ice_elemental_hits", "int");
fire_elemental_hits = 0;
ice_elemental_hits = 0;


NewLevelVariable("fire_elemental_inkillroom", "int"); //1->inside -1->outside
NewLevelVariable("ice_elemental_inkillroom", "int");
NewLevelVariable("hero_inkillroom", "int");
NewLevelVariable("hero_insocketroom", "int");
fire_elemental_inkillroom = 0;
ice_elemental_inkillroom = 0;
hero_inkillroom = 0;
hero_insocketroom = 0;

NewLevelVariable("fire_elemental_killed", "int"); 
NewLevelVariable("ice_elemental_killed", "int"); 
fire_elemental_killed = 0;
ice_elemental_killed = 0;

NewLevelVariable("gas_damage", "float");
gas_damage = GetHitPoints(mc_ID)/2;

NewLevelVariable("items_inserted", "int");
NewLevelVariable("door_fp_inserted", "int");
NewLevelVariable("door_if_inserted", "int");
items_inserted = 0;
door_fp_inserted = 0;
door_if_inserted = 0;


NewLevelVariable("machine_effect_offset" , "float");
NewLevelVariable("machine_small_effect_height" , "float");
NewLevelVariable("machine_small_effect_offset" , "float");
machine_small_effect_height = 100.0; 
machine_small_effect_offset = -10;
machine_effect_offset = -9;                    // <-----------------------   adjust position of tube main effect here!



AddToInventory(GetObject("ice_elemental"), "cc_q_ice_flower_01", 1, 0);
AddToInventory(GetObject("fire_elemental"), "cc_q_fire_pearl_01", 1, 0);

SetImmortal(GetObject("ice_elemental"), 1);
SetImmortal(GetObject("fire_elemental"), 1);



FadeOutLight(GetLight("light_secret"), 0.0);
FadeOutLight(GetLight("Light_Fire"), 0.0);
FadeOutLight(GetLight("Light_Ice"), 0.0);
FadeOutWall(GetWall("corner1"), 0.0);
FadeOutWall(GetWall("corner2"), 0.0);
FadeOutWall(GetWall("corner3"), 0.0);
FadeOutWall(GetWall("corner4"), 0.0);
FadeOutWall(GetWall("corner5"), 0.0);
FadeOutWall(GetWall("corner6"), 0.0);
FadeOutWall(GetWall("corner7"), 0.0);
FadeOutWall(GetWall("corner8"), 0.0);


StartGlobalSettings();

StartAtPos();
