
void InfluenceForceObjectSpawn(int idCreature, string sEffectID1, string sEffectID2, float fCallTime, float fLifeTime)
{
	InfluenceForceObjectSpawn(idCreature, sEffectID1, sEffectID2, fCallTime, fLifeTime, -1200, -1500);
}

void InfluenceForceObjectSpawn(int idCreature, string sEffectID1, string sEffectID2, float fCallTime, float fLifeTime, float fMinForce, float fMaxForce)
{
	InfluenceForceObjectSpawn(idCreature, sEffectID1, sEffectID2, fCallTime, fLifeTime, -1200, -1500, "");
}

void InfluenceForceObjectSpawn(int idCreature, string sEffectID1, string sEffectID2, float fCallTime, float fLifeTime, float fMinForce, float fMaxForce, string sEffectIDParent, float fEffectParentFade)
{
	int idEffect=AddEffectObject(sEffectIDParent,0,0,0,idCreature);
	SetWorldID(idEffect,  "InfluenceForceObjectSpawnObjParent_"+string(idCreature));

	InfluenceForceObjectSpawn(idCreature, sEffectID1, sEffectID2, fCallTime, fLifeTime, -1200, -1500, sEffectIDParent, fEffectParentFade, 0);
}

void InfluenceForceObjectSpawn(int idCreature, string sEffectID1, string sEffectID2, float fCallTime, float fLifeTime, float fMinForce, float fMaxForce, string sEffectIDParent, float fEffectParentFade, int iWasVisible)
{
	if ((!IsValidObject(idCreature))||(IsDead(idCreature))||(!IsCreature(idCreature))) return;

	float fCall;
	string sEffectID;
	int idEffect, i;
	if (IsObjectOnScreen(idCreature))
	{
		if ((iWasVisible==0)&&(sEffectIDParent!=""))
		{
			i=GetAllObjectsWithWorldID("InfluenceForceObjectSpawnObjParent_"+string(idCreature));
			while (i-->0)
			{
				SetWorldID(objList[i], "");

				fCall=fEffectParentFade;
				FadeOut(objList[i], fCall);
				RequestRunScript("int id="+string(objList[i])+"; if (!IsValidObject(id)) return; RemoveObject(id);",fCall);
			}
			iWasVisible=1;
		}
		if (GetLastEnemy(idCreature)==-1)
		{
			sEffectID=sEffectID1;
		}
		else
		{
			sEffectID=sEffectID2;
		}
		idEffect=AddObject(sEffectID, GetPosX(idCreature),GetPosY(idCreature), 0);
		SetWorldID(idEffect, "InfluenceForceObjectSpawnObj_"+string(idCreature));
		AddInfluence(idEffect, "force", fLifeTime, fMinForce+rand()*(fMaxForce-fMinForce), idCreature);
		RequestRunScript("int id="+string(idEffect)+"; if (!IsValidObject(id)) return; RemoveObject(id);", fLifeTime);
		fCall=fCallTime;
	}
	else
	{
		if ((iWasVisible!=0)&&(sEffectIDParent!=""))
		{
			idEffect=AddEffectObject(sEffectIDParent,0,0,0,idCreature);
			SetWorldID(idEffect,  "InfluenceForceObjectSpawnObjParent_"+string(idCreature));
			FadeOut(idEffect, 0);
			FadeIn(idEffect, fLifeTime*0.75);
			iWasVisible=0;
		}
		fCall=1.0+rand()*0.5+min(Distance(mc_ID,idCreature)/32.0/30.0,15.0);
	}

	RequestRunScript("InfluenceForceObjectSpawn("+
					 string(idCreature)+",\""+sEffectID1+"\",\""+sEffectID2+"\","+
					 string(fCallTime)+","+string(fLifeTime)+","+
					 string(fMinForce)+","+string(fMaxForce)+","+
					 "\""+sEffectIDParent+"\","+string(fEffectParentFade)+","
					 +string(iWasVisible)+");", fCall);
}

// InfluenceForceObjectSpawn(mc_ID, "CarcassFlyEffectObject", 0.2, 5.0);

void DeleteInfluenceForceObjectSpawn(int idCreature, float fFadeTime)
{
	DeleteInfluenceForceObjectSpawn(idCreature, fFadeTime, "");
}

void DeleteInfluenceForceObjectSpawn(int idCreature, float fFadeTime, string sEffectID)
{
	int i=GetAllObjectsWithWorldID("InfluenceForceObjectSpawnObj_"+string(idCreature));
	while (i-->0)
	{
		FadeOut(objList[i],fFadeTime);
		RemoveInfluence(objList[i], "force");
		RequestRunScript("int id="+string(objList[i])+"; if (!IsValidObject(id)) return; RemoveObject(id);", fFadeTime);
		if (sEffectID!="")
		{
			AddEffect(sEffectID,GetPosX(objList[i]),GetPosY(objList[i]),0);
		}
	}

	i=GetAllObjectsWithWorldID("InfluenceForceObjectSpawnObjParent_"+string(idCreature));
	while (i-->0)
	{
		FadeOut(objList[i],fFadeTime);
		RemoveInfluence(objList[i], "force");
		RequestRunScript("int id="+string(objList[i])+"; if (!IsValidObject(id)) return; RemoveObject(id);", fFadeTime);
		if (sEffectID!="")
		{
			AddEffect(sEffectID,GetPosX(objList[i]),GetPosY(objList[i]),0);
		}
	}
}
