// Push the object that was hit towards the direction
// the wave(particle) is heading

void machineChamberWavePush(float distance, float time, float force)
{
	// Declaring all variables here because of some stack error
	// message inside loop with the angle variable

	float angle = GetAngle(obj[0]); // axis direction angle

	float dx = 0.0;
	float dy = 0.0;

	float x = 0.0;
	float y = 0.0;

	float maxDist = 0.0;

	// normalized axis direction vector
	float xa = cos(angle); 
	float ya = sin(angle);

	int creatorID = GetCreator(obj[0]);

	float xc = GetPosX(creatorID);
	float yc = GetPosY(creatorID);

	int forceObjectId = -1;
	int creatureId = -1;

	float interPerc = 0.0;

	float xt = 0.0; // temp
	float yt = 0.0;

	float t = 0.0;

	// Add force objects
	int i;
	for (i = 0; i < obj[1]; i++)
	{
		creatureId = objList[i];
		
		if( IsValidObject(creatureId) &&
			IsCreature(creatureId) &&
			!IsInfluenced(creatureId, "Shield") &&
			creatureId != creatorID )
		{
			x = GetPosX(creatureId);
			y = GetPosY(creatureId);

			// vector from creator to shot/creature
			xt = x - xc;
			yt = y - yc;

			// Location of forceObject with maximum distance
			dx = x + distance * xa;
			dy = y + distance * ya;

			// percentage of distance creature<->forceObject before we hit a barricade
			interPerc = GetIntersection(x, y, dx, dy, 3);

			// Location of forceObject with possible distance
			// Scaled because of visible parts of walls that match not the walls boundary
			// line.
			dx = x + max(((interPerc * distance)-32), 0.0) * xa;
			dy = y + max(((interPerc * distance)-32), 0.0) * ya;
			
			// rescale time
			t = interPerc * time;

			// Add force object in wave propagation direction to creature
			forceObjectId = AddObject("Empty Object2", dx, dy, 0.0, -1, 0);
			SetLifeSpan(forceObjectId, t);
			AddInfluence(creatureId, "force", t, force, forceObjectId);
		}
	}
}