//Returns objId1's orientation towards objId2 (0=looking at objId2, >0=turned away clockwise, <0=turned away ccw)
float orientation(int objId1, int objId2) {
	int obj1PosX = GetPosX(objId1);
	int obj1PosY = GetPosY(objId1);

	int obj2PosX = GetPosX(objId2);
	int obj2PosY = GetPosY(objId2);

	float vectorx = obj2PosX-obj1PosX;
	float vectory = obj2PosY-obj1PosY;

	float beta = DEG(GetAngle(objId1));
	float alpha = DEG(atan(vectory/vectorx));

	if(vectorx<=0.0 && vectory<=0.0)
	{
		alpha=-180.0+alpha;
	}
	if(vectorx<=0.0 && vectory>=0.0)
	{
		alpha=180.0+alpha;
	}

	float tmp=0.0;
	tmp=beta-alpha;
	if(tmp<-180.0)
	{
		tmp=360.0+tmp;
	}
	if(tmp>180.0)
	{
		tmp=-360.0+tmp;
	}
	return tmp;
}
