// To make the InGameSequence creation easier

// The current CameraTime
NewGameVariable("fCamTime", "float");

// Start a Sequence
void StartInGameSequence()
{
	DisableInput(0);
	DisableInput(1);
	SetGameMode(1);
	SetCameraMode(1);

	fCamTime=0;
}

void EndInGameSequence()
{
	SetGameMode(0);
	EnableInput(0);
	EnableInput(1);
	ClearAI(mc_ID);
	SetCameraMode(0);
}

void ReseteCam()
{
	SetCameraMode(0);
	SetCameraMode(1);

	fCamTime=0;
}

void SetMode(int iMode, int iState)
{
	if (iMode&1)
	{
		if (iState)
			DisableInput(0);
		else
			EnableInput(0);
	}
	if (iMode&2)
	{
		SetCameraMode(iState);
	}
	if (iMode&4)
	{
		SetGameMode(iState);
	}
	if (iMode&8)
	{
		fCamTime=0;
	}
	if (iMode&16)
	{
		if (iState)
			DisableInput(1);
		else
			EnableInput(1);
	}
}

// Sets the cam at the given time to the object's properties, and saves the time
void SetCamObj(float fTime, string sObj)
{
	int idObj = GetObject(sObj);
	SetCameraView(fTime, GetPosX(idObj),GetPosY(idObj),GetHeight(idObj), GetObjectFloat(idObj, 1), DEG(GetAngle(idObj)),GetObjectFloat(idObj, 2));
	fCamTime=fTime;
}

// Sets the cam at the given time relative to the current cam-time to the object's properties, and saves the time
void SetCamObjRel(float fTime, string sObj)
{
	SetCamObj(fCamTime+fTime, sObj);
}

void SetCamObj(float fTime, string sObj, float fHeight, float fDistance, float fPitch, float fYaw) 
{
	int idObj = GetObject(sObj);
	SetCameraView(fTime, GetPosX(idObj),GetPosY(idObj),fHeight, fDistance, DEG(GetAngle(idObj)),fYaw);
	fCamTime=fTime;
}

void SetCamObjRel(float fTime, string sObj, float fHeight, float fDistance, float fPitch, float fYaw)
{
	SetCamObj(fCamTime+fTime, sObj, fHeight, fDistance, fPitch, fYaw);
}

void SetCamObj(float fTime, string sObj, float fHeight, float fDistance, float fPitch, float fYaw, float fPitchRel) 
{
	int idObj = GetObject(sObj);
	SetCameraView(fTime, GetPosX(idObj),GetPosY(idObj),fHeight, fDistance, DEG(GetAngle(idObj))+fPitchRel,fYaw);
	fCamTime=fTime;
}

void SetCamObjRel(float fTime, string sObj, float fHeight, float fDistance, float fPitch, float fYaw, float fPitchRel)
{
	SetCamObj(fCamTime+fTime, sObj, fHeight, fDistance, fPitch, fYaw, fPitchRel);
}

void SetCamCreature(float fTime, int idCreature, float fHeight, float fDistance, float fYaw, float fPitch)
{
	SetCameraView(fTime, GetPosX(idCreature), GetPosY(idCreature), GetHeight(idCreature)+fHeight, fDistance, fYaw+DEG(GetAngle(idCreature)), fPitch);
	fCamTime=fTime;
}

void SetCamCreatureRel(float fTime, int idCreature, float fHeight, float fDistance, float fYaw, float fPitch)
{
	SetCamCreature(fCamTime+fTime, idCreature, fHeight, fDistance, fYaw, fPitch);
}

//sets CameraMode to "ingame" and the camera to the object's properties at the given time
void SetCamObjInCamMode(float fTime, string sObj)
{
	SetCameraMode(1);
	SetCamObj(fTime, sObj);

}

//sets the cam to the object's properties in the screenshot mode
void SetCamObjScrShot(string sObj)
{
	int idObj = GetObject(sObj);
	SetScrShotCam(GetPosX(idObj),GetPosY(idObj),GetHeight(idObj), GetObjectFloat(idObj, 1), DEG(GetAngle(idObj)),GetObjectFloat(idObj, 2));
}


//fades in and out and sets the camera to a certain angle and distance to the MC
//todo: integrate into dialoge handling

void StartDialogSequence()
{
	FadeOutWorld(1,0.5);	//halbe Sek. fade to black
	Wait(1); return;		//halbe Sekunde schwarz
	SetCameraMode(1);
	SetCamCreature(0, mc_ID, 100, 100, 0, 35);
	FadeOutWorld(0,0.5);		//fade in
	Wait(0.5); return;	// damit man sich nicht bewegen kann, bevor full fade in
		
}

//fades in and out and resets CameraMode
//todo: integrate into dialoge handling

void EndDialogSequence()
{
	FadeOutWorld(1,0.5);	//halbe Sek. fade to black
	Wait(1); return;		//halbe Sekunde schwarz
	SetCameraMode(0);
	FadeOutWorld(0,0.5);	//fade in
	Wait(0.5); return;	
	
}

//DO NOT USE!
//sets the cam during dialogs relative to the hero, fdistanceFront and fdistanceSide are relative to hero's orientation
//todo 
void SetCamDialoge(float fTime, float fDistanceFront, float fDistanceSide, float fHeight, float fDistance, float fYaw, float fPitch)
{
	/* formeln stimmen nicht
	float fAddFrontX = cos(90-DEG(GetAngle(mc_ID)))*fDistanceFront;
	float fAddFrontY = sin(90-DEG(GetAngle(mc_ID)))*fDistanceFront;

	float fAddSideX = cos(DEG(GetAngle(mc_ID)))*fDistanceSide;
	float fAddSideY = sin(DEG(GetAngle(mc_ID)))*fDistanceSide;
	Message(3, fAddSideX);
	SetCameraView(fTime, GetPosX(mc_ID)+fAddFrontX+fAddSideX, GetPosY(mc_ID)+fAddFrontY+fAddSideY, GetHeight(mc_ID)+fHeight, fDistance, fYaw+DEG(GetAngle(mc_ID)), fPitch);
	*/
}

// OLD! DON'T USE IT ANYMORE
void SetCameraViewStr(float fTime, string sObj)
{
	int idObj = GetObject(sObj);
	SetCameraView(fTime, GetPosX(idObj),GetPosY(idObj),GetHeight(idObj), GetObjectFloat(idObj, 1), DEG(GetAngle(idObj)),GetObjectFloat(idObj, 2));
}


/***********************************************/

float ShowText(string sMsg)
{
	int WordWarp=50;
	float Duration=ShowTextCalc(sMsg);

	for (int i=1; i*WordWarp<strlen(sMsg); i++)
		sMsg[i*WordWarp]+="\n";

	Message(Duration, sMsg);

	return Duration;
}

float ShowTextCalc(string sMsg)
{
	return 0.1*float(strlen(sMsg));
}

/***********************************************/

void rotate(int Input)
{
	float fTime=8.0;

	if (Input==1)
	{
		DisableInput(0);DisableInput(1);
		RequestRunScript("EnableInput(0);EnableInput(1);", fTime*4.0/3.0+0.3);
	}

	SetCameraMode(1);
	RequestRunScript("SetCameraMode(0);", fTime*4.0/3.0+0.3);
	RequestRunScript("SetHighlight(mc_ID, 2);Wait(0.3);return;SetHighlight(mc_ID, -1);", fTime/3.0-0.3);
	RequestRunScript("SetHighlight(mc_ID, 2);Wait(0.3);return;SetHighlight(mc_ID, -1);", fTime*4.0/3.0);
	for (int i=0; i<5; i++)
	{
		SetCamCreature(float(i)*fTime/3.0, mc_ID, 32, 250,float(i)*360.0/3.0,35);
	}
}
