int i = 0;

// -------------------------------------------------------------

int advanceCostHitpoint = 1;
int advanceCostMana = 1;
int advanceCostStrength = 2;
int advanceCostSpellpower = 2;

int advancePointsPerLevel = 10;

int advanceGainHitpoint = 1;
int advanceGainMana = 2;
int advanceGainStrength = 1;
int advanceGainSpellpower = 1;

int hitpointBaseValue = 30;
int manaBaseValue = 20;
int bloodmagicBaseValue = 10;
int soulmagicBaseValue = 10;

// -------------------------------------------------------------

int level = 0;
int hitpoints = 0;
int mana = 0;
int bloodmagic = 0;
int soulmagic = 0;
int isBloodmagic = 0;
int isSoulmagic = 0;

float percentageMagic = 0.0;
float percentageMana = 0.0;


// -------------------------------------------------------------

void addItem(string name)
{
	AddToInventory(mc_ID, name, 1, 1);
}

void addItem(string name, int nr)
{
	AddToInventory(mc_ID, name, nr, 1);
}

void addHumanoidTestItems(int n, int might)
{
	int j;
	for (j = 0; j < n; j++)
	{
		AddTreasure(mc_ID, "humanoid_test", might);
	}
}


// Add n health potions for level
void addHealthPotions(int level, int n)
{
	if (level <= 10)
	{
		addItem("g_t_healthpotion_01", n);
		return;
	}
	if (level <= 25)
	{
		addItem("g_t_healthpotion_02", n);
		return;
	}
	addItem("g_t_healthpotion_03", n);
}


// Return might for this level
int getMightForLevel(int level)
{
	if (level > 29)
	{
		return 5;
	}
	if (level > 25)
	{
		return 4;
	}
	if (level > 22)
	{
		return 3;
	}
	if (level > 14)
	{
		return 2;
	}
	return 1;
}


// Add staff for this might
void addStaff(int might)
{
	if (isBloodmagic)
	{
		if (might == 1)
		{
			addItem("staff_bone01");
		}
		if (might == 2)
		{
			addItem("staff_bone02");
		}
		if (might == 3)
		{
			addItem("staff_bone03");
		}
		if (might == 4)
		{
			addItem("staff_bone04");
		}
		if (might == 5)
		{
			addItem("staff_bone05");
		}
		return;
	}

	if (isSoulmagic)
	{
		if (might == 1)
		{
			addItem("staff_glass01");
		}
		if (might == 2)
		{
			addItem("staff_glass02");
		}
		if (might == 3)
		{
			addItem("staff_glass03");
		}
		if (might == 4)
		{
			addItem("staff_glass04");
		}
		if (might == 5)
		{
			addItem("staff_glass05");
		}
	}
}


// Equip hero with items for this level
void equipHero(int level)
{
	int might = getMightForLevel(level);

	AddTreasure(mc_ID, "gorlin_bracer",   might, 0);
	AddTreasure(mc_ID, "gorlin_head",     might, 0);
	AddTreasure(mc_ID, "gorlin_pauldron", might, 0);
	AddTreasure(mc_ID, "gorlin_footware", might, 0);
	AddTreasure(mc_ID, "gorlin_belt",     might, 0);
	AddTreasure(mc_ID, "gorlin_gloves",   might, 0);
	AddTreasure(mc_ID, "gorlin_outfit",   might, 0);
	AddTreasure(mc_ID, "gorlin_weapon",   might, 0);
	AddTreasure(mc_ID, "Ringe",           might, 0);

	// add staff for might and blood|soulmagic
	addStaff(might);

	if (level > 1)
	{
		AddTreasure(mc_ID, "Horatio", 4);
		AddTreasure(mc_ID, "Severin", 4);
		AddTreasure(mc_ID, "Dolcina", 4);
	}
	
	if (level > 7)
	{
		AddTreasure(mc_ID, "Tertius", 4);
	}
	
	if (level > 9)
	{
		AddTreasure(mc_ID, "SpiderQueen", 4);
		AddTreasure(mc_ID, "CrabMama", 4);
	}

	if (level > 23)
	{
		AddTreasure(mc_ID, "Gyrons_Rettung", 4);
		AddTreasure(mc_ID, "torturemaster", 4);

		AddTreasure(mc_ID, "Harassys", 4);
		AddTreasure(mc_ID, "Fraazzz", 4);
	}

	if (level > 26 )
	{
		AddTreasure(mc_ID, "Gajan", 4);
		AddTreasure(mc_ID, "Anjaous_Heilung", 4);
	}

	if (level > 30)
	{
		AddTreasure(mc_ID, "Statuen", 4);
	}
}


// -------------------------------------------------------------

int getAdvancePoints(int level)
{
	return (level - 1) * advancePointsPerLevel;
}

int getXP(int level)
{
	return (level - 1) * level * 50;
}

// this spends advancepoints based on their gain and cost values
void setHeroLevelStatic(int level)
{
	int xp = getXP(level);

	SetExperience(mc_ID, xp);

	int advancePoints = getAdvancePoints(level);

	int pointsForMagic = percentageMagic * advancePoints;
	int pointsForMana = percentageMana * advancePoints; 
	int pointsForSpells = advancePoints - pointsForMagic - pointsForMana; // the rest as choice for e.g. spells

	SetHitPoints(mc_ID, hitpointBaseValue);
	SetManaMax(mc_ID, pointsForMana / advanceCostMana * advanceGainMana + manaBaseValue );

	if (isBloodmagic)
	{
		SetStrength(mc_ID, pointsForMagic / advanceCostStrength * advanceGainStrength + bloodmagicBaseValue);
		SetSpellPower(mc_ID, soulmagicBaseValue);
	}
	if (isSoulmagic)
	{
		SetStrength(mc_ID, bloodmagicBaseValue);
		SetSpellPower(mc_ID, pointsForMagic / advanceCostSpellpower * advanceGainSpellpower + soulmagicBaseValue);
	}

	// rest can be chosen (e.g. spells)
	SetAdvancePoints(mc_ID, pointsForSpells);
}

/*
// TODO this is seriously foobared!
// Not used anymore but might be handy later
int nOfItems = 0;
string equipmentList[15];

void tempRemoveEquipment()
{
	// not equipped items
	nOfItems = GetAllItemsInInventory(mc_ID);
	int i;
	for (i = 0; i < 15; i++)
	{
		// equipped items
		equipmentList[i] = GetEquipment(mc_ID, i+1);
	}
}

void tempAddEquipment()
{
	int i;
	for (i = 0; i < nOfItems; i++)
	{
		// not equipped items
		AddToInventory(mc_ID, sTmp[i], 1, 0);
	}
	for (i = 0; i < 15; i++)
	{
		// equipped items
		addItem(equipmentList[i]);
	}
}
*/

// -------------------------------------------------------------
void showChangeValuesMenu()
{
	hitpoints = GetHitPoints(mc_ID, 0);
	mana = GetManaMax(mc_ID, 0);
	bloodmagic = GetStrength(mc_ID);
	soulmagic = GetSpellPower(mc_ID);

	SelectMenu("|c311Chose Option (changes directly):");

	i = 1;  AddToSelectMenu("Hitpoints++"); 
	i = 2;  AddToSelectMenu("Hitpoints+"); 
	i = 3;  AddToSelectMenu("Hitpoints-");  
	i = 4;  AddToSelectMenu("Hitpoints--");  
	i = 5;  AddToSelectMenu("Mana++"); 
	i = 6;  AddToSelectMenu("Mana+"); 
	i = 7;  AddToSelectMenu("Mana-");  
	i = 8;  AddToSelectMenu("Mana--");  
	i = 9;  AddToSelectMenu("Soulmagic++"); 
	i = 10; AddToSelectMenu("Soulmagic+"); 
	i = 11; AddToSelectMenu("Soulmagic-");  
	i = 12; AddToSelectMenu("Soulmagic--");  
	i = 13; AddToSelectMenu("Bloodmagic++"); 
	i = 14; AddToSelectMenu("Bloodmagic+"); 
	i = 15; AddToSelectMenu("Bloodmagic-");  
	i = 16; AddToSelectMenu("Bloodmagic--");  

	return; // reenter

	if (dlgAnswer == 0 || dlgAnswer > 16)
	{
		CloseSelectMenu(); i = 0;
		return;
	}

	if (dlgAnswer == 1)
	{
		hitpoints = hitpoints + 5;		
	}
	else if (dlgAnswer == 2)
	{
		hitpoints = hitpoints + 1;		
	}
	else if (dlgAnswer == 3)
	{
		hitpoints = hitpoints - 1;		
	}
	else if (dlgAnswer == 4)
	{
		hitpoints = hitpoints - 5;		
	}
	else if (dlgAnswer == 5)
	{
		mana = mana + 5;		
	}
	else if (dlgAnswer == 6)
	{
		mana = mana + 1;		
	}
	else if (dlgAnswer == 7)
	{
		mana = mana - 1;		
	}
	else if (dlgAnswer == 8)
	{
		mana = mana - 5;		
	}
	else if (dlgAnswer == 9)
	{
		soulmagic = soulmagic + 5;		
	}
	else if (dlgAnswer == 10)
	{
		soulmagic = soulmagic + 1;		
	}
	else if (dlgAnswer == 11)
	{
		soulmagic = soulmagic - 1;		
	}
	else if (dlgAnswer == 12)
	{
		soulmagic = soulmagic - 5;		
	}
	else if (dlgAnswer == 13)
	{
		bloodmagic = bloodmagic + 5;		
	}
	else if (dlgAnswer == 14)
	{
		bloodmagic = bloodmagic + 1;		
	}
	else if (dlgAnswer == 15)
	{
		bloodmagic = bloodmagic - 1;		
	}
	else if (dlgAnswer == 16)
	{
		bloodmagic = bloodmagic - 5;		
	}

	SetHitPoints(mc_ID, hitpoints);
	SetManaMax(mc_ID, mana);
	SetStrength(mc_ID, bloodmagic);
	SetSpellPower(mc_ID, soulmagic);

	CloseSelectMenu(); i = 0;
	showChangeValuesMenu();
}

// -------------------------------------------------------------

// -------------------------------------------------------------
// Main menu 
// -------------------------------------------------------------

SelectMenu("|c311Chose Option:");

i = 1; AddToSelectMenu("Create new character"); 
i = 2; AddToSelectMenu("Change current values");  

return; // reenter

if (dlgAnswer == 0 || dlgAnswer > 2)
{
	return;
}

if (dlgAnswer == 1)
{
// continue through to regular menus
}
else if (dlgAnswer == 2)
{
	// Change values menu
	CloseSelectMenu(); i = 0;
	showChangeValuesMenu();
	return;
}
else
{
	return; // actually done above already
}

// close main menu
CloseSelectMenu(); i = 0;

// -------------------------------------------------------------
// Branch menu 
// -------------------------------------------------------------

SelectMenu("|c311Chose Branch:");

i = 1; AddToSelectMenu("Bloodmagic"); 
i = 2; AddToSelectMenu("Soulmagic");  

return; // reenter

if (dlgAnswer == 0 || dlgAnswer > 2)
{
	return;
}

if (dlgAnswer == 1)
{
	isBloodmagic = 1;
}
else if (dlgAnswer == 2)
{
	isSoulmagic = 1;
}
else
{
	return; // actually done above already
}

// close branch menu
CloseSelectMenu(); i = 0;

// -------------------------------------------------------------
// Level menu
// -------------------------------------------------------------

SelectMenu("|c311Chose level:");
i =  1; AddToSelectMenu("Level  1");
i =  2; AddToSelectMenu("Level  2");
i =  3; AddToSelectMenu("Level  3");
i =  4; AddToSelectMenu("Level  4");
i =  5; AddToSelectMenu("Level  5");
i =  6; AddToSelectMenu("Level  6");
i =  7; AddToSelectMenu("Level  7");
i =  8; AddToSelectMenu("Level  8");
i =  9; AddToSelectMenu("Level  9");
i = 10; AddToSelectMenu("Level 10");
i = 11; AddToSelectMenu("Level 11");
i = 12; AddToSelectMenu("Level 12");
i = 13; AddToSelectMenu("Level 13");
i = 14; AddToSelectMenu("Level 14");
i = 15; AddToSelectMenu("Level 15");
i = 16; AddToSelectMenu("Level 16");
i = 17; AddToSelectMenu("Level 17");
i = 18; AddToSelectMenu("Level 18");
i = 19; AddToSelectMenu("Level 19");
i = 20; AddToSelectMenu("Level 20");
i = 21; AddToSelectMenu("Level 21");
i = 22; AddToSelectMenu("Level 22");
i = 23; AddToSelectMenu("Level 23");
i = 24; AddToSelectMenu("Level 24");
i = 25; AddToSelectMenu("Level 25");
i = 26; AddToSelectMenu("Level 26");
i = 27; AddToSelectMenu("Level 27");
i = 28; AddToSelectMenu("Level 28");
i = 29; AddToSelectMenu("Level 29");
i = 30; AddToSelectMenu("Level 30");
i = 31; AddToSelectMenu("Level 31");
i = 32; AddToSelectMenu("Level 32");
i = 33; AddToSelectMenu("Level 33");
i = 34; AddToSelectMenu("Level 34");
i = 35; AddToSelectMenu("Level 35");
i = 36; AddToSelectMenu("Level 36");
i = 37; AddToSelectMenu("Level 37");
i = 38; AddToSelectMenu("Level 38");
i = 39; AddToSelectMenu("Level 39");
i = 40; AddToSelectMenu("Level 40");

return; // reenter

if (dlgAnswer == 0 || dlgAnswer > 40)
{
	return;
}

//TODO set level
level = dlgAnswer;


if (level > 1)
{
	// close level menu
	CloseSelectMenu(); i = 0;

// -------------------------------------------------------------
// Percentage menu
// -------------------------------------------------------------

	SelectMenu("|c311Chose:");
	i =  1; AddToSelectMenu("Magic: 40% Mana: 40% Rest: 20%");
	i =  2; AddToSelectMenu("Magic: 50% Mana: 30% Rest: 20%");
	i =  3; AddToSelectMenu("Magic: 60% Mana: 20% Rest: 20%");
	i =  4; AddToSelectMenu("Magic: 70% Mana: 10% Rest: 20%");
	i =  5; AddToSelectMenu("Magic: 50% Mana: 40% Rest: 10%");
	i =  6; AddToSelectMenu("Magic: 60% Mana: 30% Rest: 10%");
	i =  7; AddToSelectMenu("Magic: 70% Mana: 20% Rest: 10%");
	i =  8; AddToSelectMenu("Magic: 80% Mana: 10% Rest: 10%");
	i =  9; AddToSelectMenu("Magic: 40% Mana: 30% Rest: 30%");
	i = 10; AddToSelectMenu("Magic: 30% Mana: 20% Rest: 50%");
	i = 11; AddToSelectMenu("Magic:  0% Mana:  0% Rest:100%");
	
	return; // reenter

	if (dlgAnswer == 0 || dlgAnswer > 40)
	{
		return;
	}

	if (dlgAnswer == 1)
	{
		percentageMagic = 0.4;
		percentageMana  = 0.4;
	}
	else if (dlgAnswer == 2)
	{
		percentageMagic = 0.5;
		percentageMana  = 0.3;
	}
	else if (dlgAnswer == 3)
	{
		percentageMagic = 0.6;
		percentageMana  = 0.2;
	}
	else if (dlgAnswer == 4)
	{
		percentageMagic = 0.7;
		percentageMana  = 0.1;
	}

	else if (dlgAnswer == 5)
	{
		percentageMagic = 0.5;
		percentageMana  = 0.4;
	}
	else if (dlgAnswer == 6)
	{
		percentageMagic = 0.6;
		percentageMana  = 0.3;
	}
	else if (dlgAnswer == 7)
	{
		percentageMagic = 0.7;
		percentageMana  = 0.2;
	}
	else if (dlgAnswer == 8)
	{
		percentageMagic = 0.8;
		percentageMana  = 0.1;
	}
	else if (dlgAnswer == 9)
	{
		percentageMagic = 0.4;
		percentageMana  = 0.3;
	}
	else if (dlgAnswer == 10)
	{
		percentageMagic = 0.3;
		percentageMana  = 0.2;
	}
	else if (dlgAnswer == 11)
	{
		percentageMagic = 0.0;
		percentageMana  = 0.0;
	}
	else
	{
		return; // actually done above already
	}
}
else
{
	percentageMagic = 0.0;
	percentageMana  = 0.0;
}

// -------------------------------------------------------------
// Set changes
// -------------------------------------------------------------

// Clear inventory
EmptyInventory(mc_ID, 1);

// Set level
setHeroLevelStatic(level);

// Add amulet
addItem("g_q_heroamulet");

// Add makeHero() scroll
addItem("db_makehero");

// Add soulstone
if (level >= 10)
{
	if (isBloodmagic)
	{
		addItem("cc_q_soulcrystal_combat_01");
	}
	if (isSoulmagic)
	{
		addItem("cc_q_soulcrystal_spell_01");
	}
}

// Add health potions
addHealthPotions(level, 3);

// Add might items, staff and quest/boss items for level
equipHero(level);

// Close last menu
CloseSelectMenu(); i = 0;



/*
AddToSelectMenu("Taertius - Level 5"); i++;
AddToSelectMenu("Spinnenknigin - Level 9"); i++;
AddToSelectMenu("Foltermeister (Bloodmagic) - Level 21"); i++;
AddToSelectMenu("Foltermeister (Soulmagic) - Level 21"); i++;
AddToSelectMenu("Harrassys (Bloodmagic) - Level 23"); i++;
AddToSelectMenu("Harrassys (Soulmagic) - Level 23"); i++;
AddToSelectMenu("Frazzz (Bloodmagic) - Level 23"); i++;
AddToSelectMenu("Frazzz (Soulmagic) - Level 23"); i++;
AddToSelectMenu("Meganteolis (Bloodmagic) - Level 25"); i++;
AddToSelectMenu("Meganteolis (Soulmagic) - Level 25"); i++;
AddToSelectMenu("Level 27 + Items (Bloodmagic)"); i++;
AddToSelectMenu("Level 33 + Items (Bloodmagic)"); i++;
*/
/*
switch(dlgAnswer)
{
	case 0: return;

	// Tertius 
	case 1:	lvl=5;
			addItem("staff_wood01");
			break;

	// Spinnenknigin
	case 2:	lvl=9;
			addItem("staff_wood02");
			break;

	// Foltermeister bloodmagic
	case 3:	lvl=21;
			addItem("staff_bone04");
			addItem("cc_q_soulcrystal_combat_01");
			break;

	// Foltermeister soulmagic
	case 4:	lvl=21;
			addItem("staff_glass04");
			addItem("cc_q_soulcrystal_spell_01"); 
			break;

	// Harrassys bloodmagic
	case 5:	lvl=23;
			addItem("staff_bone04");
			addItem("cc_q_soulcrystal_combat_01"); 
			break;

	// Harrassys souldmagic
	case 6:	lvl=23;
			addItem("staff_glass04");
			addItem("cc_q_soulcrystal_spell_01"); 
			break;

	// Frazzz bloodmagic
	case 7:	lvl=23;
			addItem("staff_bone04");
			addItem("cc_q_soulcrystal_combat_01"); 
			break;

	// Frazzz souldmagic
	case 8:	lvl=23;
			addItem("staff_glass04");
			addItem("cc_q_soulcrystal_spell_01");
			break;

	// Meganteolis bloodmagic
	case 9:	lvl=25;
			addItem("staff_bone04");
			addItem("cc_q_soulcrystal_combat_01"); 
			break;

	// Meganteolis soulmagic
	case 10:lvl=25;
			addItem("staff_glass04");
			addItem("cc_q_soulcrystal_spell_01");
			break;

	// 27 + items blood
	case 11:lvl=27;
			addItem("staff_bone04");
			addItem("cc_q_soulcrystal_combat_01");
			addHumanoidTestItems(12, 4);
			AddTreasure(mc_ID, "Horatio", 4);
			AddTreasure(mc_ID, "Severin", 4);
			AddTreasure(mc_ID, "Dolcina", 4);
			AddTreasure(mc_ID, "Tertius", 4);
			AddTreasure(mc_ID, "SpiderQueen", 4);
			AddTreasure(mc_ID, "CrabMama", 4);
			AddTreasure(mc_ID, "Statuen", 4);
			AddTreasure(mc_ID, "Gyrons_Rettung", 4);
			AddTreasure(mc_ID, "torturemaster", 4);
			AddTreasure(mc_ID, "Harassys", 4);
			AddTreasure(mc_ID, "Fraazzz", 4);
			break;

	// 33 + items blood
	case 12:lvl=33;
			addItem("staff_bone04");
			addItem("cc_q_soulcrystal_combat_01");
			addHumanoidTestItems(8, 4);
			addHumanoidTestItems(8, 5);
			AddTreasure(mc_ID, "Horatio", 4);
			AddTreasure(mc_ID, "Severin", 4);
			AddTreasure(mc_ID, "Dolcina", 4);
			AddTreasure(mc_ID, "Tertius", 4);
			AddTreasure(mc_ID, "SpiderQueen", 4);
			AddTreasure(mc_ID, "CrabMama", 4);
			AddTreasure(mc_ID, "Statuen", 4);
			AddTreasure(mc_ID, "Gyrons_Rettung", 4);
			AddTreasure(mc_ID, "torturemaster", 4);
			AddTreasure(mc_ID, "Harassys", 4);
			AddTreasure(mc_ID, "Fraazzz", 4);
			break;
}
*/

