
if (GetStory("ShootingArena")!=2) exit;

int idTarget = GetObject("ShootingArenaTarget");
int idPos1, idPos2;
int iShootType;
int iFirstTime=0;
int X,Y;
float fInfo;

void EnableTarget()
{
	SetSolid(idTarget, 1);
	SetOnCollision(idTarget, "scripts\\seminarrooms\\quests\\tutorial\\shooting\\shooting_hit.c");
	FadeIn(idTarget, 1);
}

void DisableTarget()
{
	SetSolid(idTarget, 0);
	SetOnCollision(idTarget, "");
	FadeOut(idTarget, 0);
}

DebugMessage(3,"INFO: OnCollision Hits="+string(ShootingArenaHits));

switch (ShootingArenaHits)
{
	// 1st part
	case 0:
		iFirstTime=1;
	case 1:
	case 2:
	case 3:
	case 4:
	case 5:
		iShootType=0;
		fInfo=64;

		idPos1=GetObject("Shooting1.1");
		idPos2=GetObject("Shooting1.2");
		break;

	// 2nd part
	case 6:
		iFirstTime=1;
	case 7:
	case 8:
		iShootType=1;
		fInfo=6;

		idPos1=GetObject("Shooting2.1");
		idPos2=GetObject("Shooting2.2");
		break;

	// 3rd part
	case 9:
		iFirstTime=1;
	case 10:
	case 11:
	case 12:
	case 13:
	case 14:
		iShootType=0;
		fInfo=64;

		idPos1=GetObject("Shooting3.1");
		idPos2=GetObject("Shooting3.2");
		break;

	// 4th part
	case 15:
		iFirstTime=1;
	case 16:
	case 17:
		iShootType=1;
		fInfo=12;

		idPos1=GetObject("Shooting4.1");
		idPos2=GetObject("Shooting4.2");
		break;

	// Finish
	case 18:
		FadeOut(idTarget,0);
		SetMoveSpd(idTarget, 0);

		SetStory("ShootingArena", 3);

		// Open shooting-arena door
		SetUseState(GetObject("ShootingArenaDoor"), 1);
		SetWallSolid(GetWall("ShootingArenaDoorWall"), 0);

		Message(3,"Finish");
		ShootingArenaAccuracy=float(ShootingArenaHits)/float(ShootingArenaHits+ShootingArenaMisses)*100;
		Message(4, "Your accuracy: "+string(ShootingArenaAccuracy)+"%");
		// Bad accuracy
		if (ShootingArenaAccuracy<=ShootingArenaBestAccuracy)
		{
			Message(4,"Best accuracy: "+string(ShootingArenaBestAccuracy)+"%");
		}
		// New record
		else
		{
			ShootingArenaBestAccuracy=ShootingArenaAccuracy;
			Message(4,"New Record");
		}


		exit;

	default:
		// ERROR //
		exit;
}

ShootingArenaHits++;

switch (iShootType)
{
	case 0:
		// Disable movepath
		if (iFirstTime==1)
		{
			SetMoveSpd(idTarget,1);
		}

		DisableTarget();

		// Move to random pos
		X=int(rand()*(GetPosX(idPos2)-GetPosX(idPos1))+GetPosX(idPos1));
		Y=int(rand()*(GetPosY(idPos2)-GetPosY(idPos1))+GetPosY(idPos1));
		SetPos(idTarget, X,Y);
		SetMovePath( idTarget, 0,X,Y+fInfo/2, 1,X,Y-fInfo/2, 2,X,Y+fInfo/2);
		SetPathLoop(idTarget, 2);

		Wait(0.5); return;

		EnableTarget();
		break;
	case 1:
		// Set move path only on first time
		if (iFirstTime==1)
		{
			DisableTarget();

			SetPos(idTarget, GetPosX(idPos1),GetPosY(idPos1));
			SetMovePath(idTarget, 0, GetPosX(idPos1), GetPosY(idPos1), fInfo, GetPosX(idPos2), GetPosY(idPos2), 2*fInfo, GetPosX(idPos1), GetPosY(idPos1));
			SetMoveSpd(idTarget, 2*fInfo);
			SetPathLoop(idTarget, fInfo);
			Wait(0.5); return;

			EnableTarget();
		}
		else
		{
			DisableTarget();

			Wait(0.5); return;
			SetPathTime(idTarget, rand()*fInfo*2);

			EnableTarget();
		}
		break;
	default:
		// ERROR //
		exit;
}