// On init the Watcher script is loaded
// other initialization may be done
 
// structure of init.c file is the following
// at first story constants are declared
// then level constants seperated in theme blocks meaning variables are grouped by semantic meaning
// then level variables are initialized and declared
// then Work is done which has to be done to initialize level


// ============================================================================
// ||                  story variable constants                              ||
// ============================================================================
NewLevelVariable("ghostRitualString","string");
ghostRitualString="Ghost Ritual";
NewLevelVariable("spokenWithSiberius","int");
spokenWithSiberius=1;
NewLevelVariable("corpseFound","int");
corpseFound=2;
NewLevelVariable("bookFound","int");
bookFound=4;
NewLevelVariable("readyForRitual","int");
readyForRitual=8;
NewLevelVariable("ritualSuccess","int");
ritualSuccess=9;
NewLevelVariable("spokenWithBaradun","int");
spokenWithBaradun=10;
NewLevelVariable("finished","int");
finished=12;

// ============================================================================

// ============================================================================
 //necessary for follow_mc script
SetWorldID(mc_ID,McWorldID);
// ============================================================================
// ||                         level constants                                ||
// ============================================================================
NewLevelVariable("baradunID","string"); //worldID and objectID of baradun
baradunID="Baradun";
NewLevelVariable("siberiusID","string");//worldID and objectID of siberius
siberiusID="Siberius";
NewLevelVariable("corpseID","string");//worldID and objectID of baradun's corpse
corpseID="Baradun Corpse";
NewLevelVariable("corpseItemID","string");//itemID of baradun's corpse
corpseItemID="Corpse of Baradun";

NewLevelVariable("ghostBookID","string");//worldID and objectID of ghost book
ghostBookID="Ghost Book";


NewLevelVariable("numberOfConjureEffects","int"); //how much effects are displayed during conjuring
numberOfConjureEffects = 2;
NewLevelVariable("conjureEffect","string",numberOfConjureEffects); //effect array
conjureEffect[0] = "FloorEffect1"; //first effect
conjureEffect[1] = "whirl 01"; //second effect

NewLevelVariable("effectDelay","float",numberOfConjureEffects); //array of pauses between effects, first pause is added after the first effect
effectDelay[0] = 2;
effectDelay[1] = 0.5;

NewLevelVariable("conjuringDistance","float"); //max distance to the corpse where conjuring remains possible
conjuringDistance=100;

NewLevelVariable("conjureTime","int"); //number of seconds in with the corpse must be clicked to conjure the ghost
conjureTime = 5;
// ============================================================================

// ============================================================================
 
// ============================================================================
HallsOfMasters = GetLevelName(); //initiating the level name for the book of the ghosts


// ============================================================================
// ||                         level variables                                ||
// ============================================================================
NewLevelVariable("baradunConjureable","int"); 


// ============================================================================
// ||                             level init                                 ||
// ============================================================================


#include "scripts\\testGhostRitual\\scriptPathes.c" //including pathes to the scripts which can be adjusted, all pathes to files are stored there if they are run by a script

#include "scripts\\testGhostRitual\\messages\\LANG\\messages.c"

//AddObject(ghostBookID,GetPosX(0),GetPosY(0));



